%{?scl:%scl_package rubygem-%{gem_name}}
%{!?scl:%global pkg_name %{name}}

%global gem_name rr
%global rubyabi 1.9.1

Summary: RR (Double Ruby) is a test double framework 
Name: %{?scl_prefix}rubygem-%{gem_name}
Version: 1.0.4
Release: 7%{?dist}
Group: Development/Languages
License: MIT
URL: http://pivotallabs.com
Source0: http://rubygems.org/gems/%{gem_name}-%{version}.gem
Requires: %{?scl_prefix}ruby(abi) = %{rubyabi}
Requires: %{?scl_prefix}ruby(rubygems) 
%{?scl:Requires: %{scl}-runtime}
BuildRequires: %{?scl_prefix}ruby(abi) = %{rubyabi}
BuildRequires: %{?scl_prefix}ruby-irb
BuildRequires: %{?scl_prefix}rubygems-devel
BuildArch: noarch
Provides: %{?scl_prefix}rubygem(%{gem_name}) = %{version}

# The following are for running test suite
BuildRequires: %{?scl_prefix}rubygem(minitest)
BuildRequires: %{?scl_prefix}rubygem(session)
BuildRequires: %{?scl_prefix}rubygem(diff-lcs)

%description
RR (Double Ruby) is a test double framework that features a rich selection of
double techniques and a terse syntax.

A Test Double is a generalization of something that replaces a real object to
make it easier to test another object. Its like a stunt double for tests.

%package doc
Summary: Documentation for %{pkg_name}
Group: Documentation
Requires: %{?scl_prefix}%{pkg_name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{pkg_name}

%prep
%{?scl:scl enable %{scl} "}
gem unpack %{SOURCE0}
%{?scl:"}

%setup -q -D -T -n %{gem_name}-%{version}

# Modify the gemspec if necessary with a patch or sed
# Also apply patches to code if necessary
# %%patch0 -p1

%{?scl:scl enable %{scl} "}
gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec
%{?scl:"}

%build
mkdir -p .%{gem_dir}

# Create the gem as gem install only works on a gem file
%{?scl:scl enable %{scl} "}
gem build %{gem_name}.gemspec
%{?scl:"}

export CONFIGURE_ARGS="--with-cflags='%{optflags}'"
# gem install compiles any C extensions and installs into a directory
# We set that to be a local directory so that we can move it into the
# buildroot in %%install
%{?scl:scl enable %{scl} "}
gem install -V \
        --local \
        --install-dir ./%{gem_dir} \
        --bindir ./%{_bindir} \
        --force \
        --rdoc \
        --ri \
        %{gem_name}-%{version}.gem
%{?scl:"}

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* %{buildroot}%{gem_dir}/

# Remove leftovers.
rm  %{buildroot}%{gem_instdir}/.gitignore
rm  %{buildroot}%{gem_instdir}/.runrc
rm  %{buildroot}%{gem_instdir}/.rvmrc
rm  %{buildroot}%{gem_instdir}/Gemfile
rm  %{buildroot}%{gem_instdir}/Gemfile.lock
rm  %{buildroot}%{gem_instdir}/%{gem_name}.gemspec
rm  %{buildroot}%{gem_instdir}/doc/todo.txt
rm  %{buildroot}%{gem_dir}/cache/%{gem_name}-%{version}.gem
rm -rf  %{buildroot}%{gem_instdir}/.yardoc

# Fixing test-suite files to avoid bundler dependency
sed -i 's/require "bundler"/#require "bundler"/g' %{buildroot}%{gem_instdir}/spec/spec_suite.rb
sed -i 's/require "bundler"/#require "bundler"/g' %{buildroot}%{gem_instdir}/spec/environment_fixture_setup.rb

# Removing rspec dependency for testunit and minitest tests
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/environment_fixture_setup.rb
sed -i 's/require "spec\/autorun"/#require "spec\/autorun"/g' %{buildroot}%{gem_instdir}/spec/environment_fixture_setup.rb
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/rr/test_unit/test_unit_integration_test.rb
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/rr/test_unit/test_unit_backtrace_test.rb
sed -i 's/require "spec"/#require "spec"/g' %{buildroot}%{gem_instdir}/spec/rr/test_unit/test_unit_integration_test.rb

%check
# Run tests
pushd %{buildroot}%{gem_instdir}
# Run individual test suites until test suite is updated to rspec 2x
%{?scl:scl enable %{scl} - << \EOF}
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb spec/rr/test_unit/test_unit_integration_test.rb
%{?scl:EOF}
%{?scl:scl enable %{scl} - << \EOF}
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb spec/rr/test_unit/test_unit_backtrace_test.rb
%{?scl:EOF}
%{?scl:scl enable %{scl} - << \EOF}
RUBYOPT="-Ilib -I%{buildroot}%{gem_extdir} -Itest" testrb spec/rr/minitest/minitest_integration_test.rb
%{?scl:EOF}
popd

# Remove leftovers.
rm  %{buildroot}%{gem_instdir}/Rakefile

%files
%dir %{gem_instdir}
%doc %{gem_instdir}/LICENSE
%{gem_libdir}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/doc
%doc %{gem_instdir}/introducting_rr.txt
%doc %{gem_instdir}/CHANGES
%doc %{gem_instdir}/README.rdoc
%{gem_instdir}/spec
%{gem_instdir}/benchmarks

%changelog
* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.4-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sun Jul 22 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-6
- Removed unnecesary dependencies
- Spec adjusted according new guidelines

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.4-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sun Feb 12 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-4
- Changelog entries fixed

* Tue Feb 07 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-3
- Updated spec file for Ruby 1.9 guidelines
- RSPec 1x tests disabled

* Tue Jan 24 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-2
- Removed unused macro from spec file
- Removed doc tag for benchmarks and spec file
- Removed cached version of the gem
- Fixed test suite files and test suite enabled at check section

* Sat Jan 21 2012 Guillermo Gómez <guillermo.gomez@gmail.com> - 1.0.4-1
- Initial package
